Imports System.Net
Imports System.IO

Public Class Request


    Private m_intTimeoutSeconds As Integer = 30
    Private m_strURL As String
    Private m_strHost As String
    Private m_strSource As String

    Public Event Status(ByVal Description As String, ByVal err As ErrObject)
    Public Event Progress(ByVal URL As String, ByVal Maximum As Integer, ByVal Value As Integer)

    Public Property TimeOutSeconds() As Integer
        Get
            TimeOutSeconds = m_intTimeoutSeconds
        End Get
        Set(ByVal Value As Integer)
            If Value < 0 Then
                Value = 1
            End If
            m_intTimeoutSeconds = Value
        End Set
    End Property

    Public Property URL() As String
        Get
            URL = m_strURL
        End Get
        Set(ByVal Value As String)
            m_strURL = Value
        End Set
    End Property

    Public ReadOnly Property Host() As String
        Get
            Host = m_strHost
        End Get
    End Property

    Public ReadOnly Property Source() As String
        Get
            Source = m_strSource
        End Get
    End Property

    Public Function GetWebPage(ByVal URL As String) As Boolean
        m_strURL = URL
        GetWebPage = GetWebPage()
    End Function

    Public Function GetWebPage() As Boolean

        'Make a guess of 20,000 if the content lenght is not not known
        'This will be averaged as we go
        Static intDefaultContentLength As Integer = 20000
        Dim strSource As String = ""
        Dim strHost As String = ""
        Dim intTotalLength As Integer
        If m_strURL = "" Then
            RaiseEvent Status("Error - blank URL", Err)
            GetWebPage = False
        Else
            Try
                RaiseEvent Status("Request", Err)
                RaiseEvent Progress(m_strURL, 0, 0)
                Dim hrqURL As HttpWebRequest = CType(WebRequest.Create(m_strURL), HttpWebRequest) 'todo get rid of the ctypes? 
                Dim hrspURL As HttpWebResponse = CType(hrqURL.GetResponse(), HttpWebResponse)
                Dim sInput As Stream = hrspURL.GetResponseStream()
                Dim srdrInput As New StreamReader(sInput)
                Dim chrBuff(255) As Char
                Dim intLen As Integer

                'Get the content length
                Dim intContentLength As Integer = hrspURL.ContentLength
                If intContentLength <= 0 Then
                    intContentLength = intDefaultContentLength
                End If
                RaiseEvent Status("Load", Err)
                Dim tmeExpire As DateTime = DateAdd(DateInterval.Second, m_intTimeoutSeconds, Now)
                Do
                    Dim strBuff As New String(chrBuff, 0, intLen)
                    'Debug.WriteLine(strBuff)
                    strSource = strSource & strBuff
                    intLen = srdrInput.Read(chrBuff, 0, 256)
                    intTotalLength = intTotalLength + intLen
                    If intTotalLength > intContentLength Then
                        intContentLength = Int(1.5 * intTotalLength)
                    End If
                    RaiseEvent Progress(m_strURL, intContentLength, intTotalLength)
                    If DateDiff(DateInterval.Second, tmeExpire, Now) > 0 Then
                        GetWebPage = False
                        Exit Do
                    End If
                Loop While intLen
                intDefaultContentLength = (intDefaultContentLength + intTotalLength) / 2
                srdrInput.Close()
                sInput.Close()
                hrspURL.Close()
                strHost = hrspURL.ResponseUri.Host
                GetWebPage = True
            Catch e As System.Net.WebException
                RaiseEvent Status("Error", Err)
                GetWebPage = False
            End Try
        End If

        RaiseEvent Progress(m_strURL, intTotalLength, intTotalLength)
        m_strHost = strHost
        m_strSource = strSource

    End Function
End Class
